unit uRatespiel;
// ********************************************************************
// K L A S S E : TRatespiel                                             
// -------------------------------------------------------------------- 
// Version   : 1.x
// Autor     : S. Spolwig, OSZ-Handel I,  10997 Berlin
// Aufgabe   : stellt das Spielobjekt im Datenmodell dar.
// Compiler  : DELPHI 4.0
// Aenderung : V. 1.2   - 20-FEB-01   Zaehler 
// ******************************************************************** 
interface
// ====================================================================
uses dialogs,sysutils;
type
  TRatespiel = class (TObject)
    private
     Geheimzahl : integer;
     Ratezahl   : integer;
     Zaehler    : integer;

    public
     constructor Create;
     procedure   Init;
     procedure   GeheimzahlErzeugen;
     procedure   SetRatezahl (rz : integer);
     procedure   ZaehlerErhoehen;
     function    GetZaehler : integer;
     function    GetStatusmeldung : string;
     function    IstFertig        : boolean;
  end;

(* ------------------------ Beschreibung --------------------------------

Create
  Auftrag: neues Spielobjekt erzeugen
Init;
  Auftrag: Geheimzahl, Ratezahl, Zaehler auf 0 setzen

GeheimzahlErzeugen;
  Auftrag: Wert zwischen 0 und 100 erzeugen und der Geheimzhal zuweisen

SetRatezahl (rz : integer);
  Auftrag: de Ratezahl eine Wert zuweisen

GetStatusmeldung : string;
  Anfrage: nach dem Ergebnis des Vergleichs(=, >, <)

IstFertig        : boolean;
  Anfrage: : ob Spiel beendet. True wenn Ratezahl = Geheimzahl

------------------------ Ende Beschreibung ---------------------------- *)

implementation
// ====================================================================

constructor TRatespiel.Create;
// --------------------------------------------------------------------
begin
  inherited Create; // was von TObject kommt
end;

procedure TRatespiel.Init;
// --------------------------------------------------------------------
begin
  Ratezahl := 0;
  GeheimzahlErzeugen;
  Zaehler := 0;
end;


procedure TRatespiel.GeheimzahlErzeugen;
// --------------------------------------------------------------------
begin
  randomize;
  Geheimzahl := random(100)+1;
end;


procedure TRatespiel.SetRatezahl (rz : integer);
// --------------------------------------------------------------------
begin
  Ratezahl := rz;
end;

procedure TRatespiel.ZaehlerErhoehen;
// --------------------------------------------------------------------
begin
  Zaehler := Zaehler + 1;
end;


function TRatespiel.GetStatusmeldung : string;
// --------------------------------------------------------------------
begin
  if Ratezahl = Geheimzahl
  then
    Result := (' Gratuliere! Richtig geraten! ')
  else
    if Ratezahl < Geheimzahl
    then Result := (' Ratezahl zu niedrig ... ')
    else Result := (' Ratezahl zu hoch ... ');
end;

function TRatespiel.IstFertig : boolean;
// --------------------------------------------------------------------
begin
  if Ratezahl = Geheimzahl
  then Result := true
  else Result := false;
end;

function TRatespiel.GetZaehler : integer;
// --------------------------------------------------------------------
begin
  result := Zaehler;
end;

END.
