unit uRatespiel;
(* ******************************************************************** *)
(* K L A S S E : TRatespiel                                             *)
(* -------------------------------------------------------------------- *)
(* Version     : 1.2                                                    *)
(* Autor       : S. Spolwig, OSZ-Handel I,  10997 Berlin                *)
(* Aufgabe     : stellt das Spielobjekt im Datenmodell dar.             *)
(* Compiler    : DELPHI 3.0                                             *)
(* ******************************************************************** *)
interface

USES uZAHL, uZaehler;

type TRatespiel = class
                    Geheimzahl,
                    Ratezahl        : TSpielzahl;
                    Versuchszaehler : TZaehler;

                    constructor Create;
                    function Vergleichsergebnis : string;  virtual;
                    function IstFertig          : boolean; virtual;
                  end;


implementation

constructor TRatespiel.Create;
(* -------------------------------------------------------------------- *)
begin
  versuchszaehler := TZaehler.Create;
  Ratezahl        := TSpielzahl.Create;
  Geheimzahl      := TSpielzahl.Create;
  Versuchszaehler.SetWert(0);
  Ratezahl.SetWert(0);
  Geheimzahl.Erzeugen;
end;


function TRatespiel.VergleichsErgebnis : string;
(* -------------------------------------------------------------------- *)
begin
  if Ratezahl.IstGleich (Geheimzahl)
  then Result := (' Gratuliere! Richtig geraten! ')
  else
    if Ratezahl.IstKleiner (Geheimzahl)
    then Result := (' zu niedrig ... ')
    else Result := (' zu hoch ... ');
end;

function TRatespiel.IstFertig : boolean;
(* -------------------------------------------------------------------- *)
begin
  if Ratezahl.IstGleich (Geheimzahl)
  then Result := true
  else Result := false;
end;

END.
