unit uSpielFenster;
(* ******************************************************************** *)
(* K L A S S E : TSpielFenster                                          *)
(* -------------------------------------------------------------------- *)
(* Version     : 1.21                                                   *)
(* Autor       : S. Spolwig, OSZ-Handel I,  10997 Berlin                *)
(* Aufgabe     : GUI fuer das Ratespiel                                 *)
(* Compiler    : DELPHI 3.0                                             *)
(* Aenderung   : V. 1.21  27-NOV-98   etwas Kosmetik                    *)
(* ******************************************************************** *)

interface

uses
   Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
   StdCtrls,

   uRatespiel; (* import: TRatespiel *)

type
  TSpielFenster = class(TForm)
                    EingabeLbl   : TLabel;
                    EingabefeldEdt: TEdit;
                    VersucheLbl: TLabel;
                    EndeBtn      : TButton;
                    ZaehlerLbl: TLabel;
                    MeldeLeisteLbl: TLabel;
                    GeheimLbl    : TLabel;
                    ProgrammkopfLbl: TLabel;

                    procedure Init;
                    procedure BeendenClick(Sender: TObject);
                    procedure TipEingeben(Sender: TObject; var Key: Char);
                    procedure DatenAktualisieren (sp: TRatespiel);
                    procedure MaskeAktualisieren (sp: TRatespiel);
                    procedure FormCreate(Sender: TObject);
                  end;

var
 SpielFenster : TSpielFenster;
 Ratespiel    : TRatespiel;


implementation

{$R *.DFM}

procedure TSpielFenster.Init;
(* -------------------------------------------------------------------- *)
begin
  Ratespiel.Create;
  EingabeFeldEdt.Text := '';
  MeldeLeisteLbl.Caption := 'Neues Spiel - neues Glck';
  MaskeAktualisieren(Ratespiel);
end;

procedure TSpielFenster.BeendenClick(Sender: TObject);
(* -------------------------------------------------------------------- *)
begin
  Close
end;


procedure TSpielFenster.TipEingeben (Sender: TObject; var Key: Char);
(* -------------------------------------------------------------------- *)
begin
 if key = chr(13)
 then
   begin
  {  try
      DatenAktualisieren(Ratespiel);
    except
      on EConvertError do
      begin
        ShowMessage(' Du hast einen ungltigen Wert eingetragen! ');
      end;
    end;   }
    DatenAktualisieren(Ratespiel);
    MeldeLeisteLbl.Caption := Ratespiel.VergleichsErgebnis;
    MaskeAktualisieren(Ratespiel);
 end;

 if Ratespiel.IstFertig
 then
   begin
     showmessage('Ende - du kannst aber auch gleich weitermachen');
     Init;
   end;
end;


procedure TSpielFenster.DatenAktualisieren (sp: TRatespiel);
(* -------------------------------------------------------------------- *)
begin
  with sp do
  begin
    Ratezahl.Setwert(strToInt(EingabeFeldEdt.Text));
    VersuchsZaehler.Erhoehen;
  end;
end;

procedure TSpielFenster.MaskeAktualisieren (sp : TRatespiel);
(* -------------------------------------------------------------------- *)
begin
  with sp do
  begin
    ZaehlerLbl.Caption   := inttostr (Versuchszaehler.GetWert);
    GeheimLbl.Caption := inttostr(Geheimzahl.GetWert);
    ZaehlerLbl.Caption   := intToStr(Versuchszaehler.GetWert);
  end;
end;

procedure TSpielFenster.FormCreate(Sender: TObject);
begin
  Ratespiel := TRatespiel.Create;
  Init;
end;


END.
