UNIT uZahl;
(* ******************************************************************** *)
(* K L A S S E : TZahl                                                  *)
(* -------------------------------------------------------------------- *)
(* Version     : 1.2                                                    *)
(* Autor       : S. Spolwig, OSZ-Handel I,  10997 Berlin                *)
(* Aufgabe     : stellt ein Objekt fuer ganze Zahlen zur Verfuegung.    *)
(* Compiler    : DELPHI  3.0                                            *)
(* ******************************************************************** *)

INTERFACE
(* ========================== Export ================================== *)
type
   TSpielzahl = class
                 protected
                  Wert : 0..100;
                 public 
                  constructor Create;
                  procedure Setwert ( w: integer);     virtual;
                  function  Getwert : integer;         virtual;
                  procedure Erzeugen;                  virtual;
                  function  IstGleich  (andereZahl : TSpielzahl ) : boolean; virtual;
                  function  IstKleiner (andereZahl : TSpielzahl)  : boolean; virtual;
                end;


IMPLEMENTATION
(* ==================================================================== *)

 constructor TSpielzahl.Create ;
(* -------------------------------------------------------------------- *)
 begin
   Wert := 0;
 end;

 procedure TSpielzahl.Setwert ( w: integer);
(* -------------------------------------------------------------------- *)
 begin
   Wert := w;
 end;

 function TSpielzahl.Getwert : integer;
(* -------------------------------------------------------------------- *)
 begin
   Result := Wert;
 end;


procedure TSpielzahl.Erzeugen;
(* -------------------------------------------------------------------- *)
begin
  randomize;
  Wert := random(100)+1;
end; (* Erzeugen *)


function TSpielzahl.IstGleich (andereZahl : TSpielzahl) : boolean;
(* -------------------------------------------------------------------- *)
begin
  IstGleich := false;
  if Wert = andereZahl.Wert
  then Result := true;
end;

function TSpielzahl.IstKleiner (andereZahl : TSpielzahl) : boolean;
(* -------------------------------------------------------------------- *)
begin
  IstKleiner := false;
  if Wert < andereZahl.Wert
  then Result := true;
end;


END. (* Unit *)